//
//  lariat-online/include/TriggerFragment.h    (W.Badgett)
//
//  Description of one LArIAT trigger, clock time, input bits 
//  trigger counter and trigger fragment number
//

#include <iostream>
#include "TriggerPattern.h"

#ifndef _TriggerFragment_h
#define _TriggerFragment_h

class TriggerFragment
{
 public:

  enum
  {
    MAX_ENTRIES = 4096
  };

#pragma pack(push,1)

  typedef struct TriggerFragment_t
  {
    uint32_t fragmentSize;
    uint32_t fragmentType;
    uint32_t nEntries;
    TriggerPattern::TriggerPattern_t * patterns;
  } TriggerFragment_t;

#pragma pack(pop)

  TriggerFragment();

  TriggerFragment_t triggerFragment;

  uint32_t streamToBuffer(std::ostream& buffer);
  uint32_t fillFromBuffer(std::istream& buffer);
  void print(std::ostream& os = std::cout);
};

std::ostream& operator<<(std::ostream& os, const TriggerFragment& e);

#endif
